stages:
  - release
  - deploy

variables:
  CONTAINER_IMAGE: ${CI_REGISTRY}/${CI_PROJECT_PATH}:${CI_BUILD_REF_NAME}_${CI_BUILD_REF}
  CONTAINER_IMAGE_LATEST: ${CI_REGISTRY}/${CI_PROJECT_PATH}:latest
  #  DOCKER_DRIVER: overlay2
  KUBECONFIG: /etc/deploy/config
  STAGING_NAMESPACE: exercise
  APP_PATH: /builds/nabil.tahri/API-Exercise

.docker_registry_template: &docker_registry
 image: docker:git
 services:
    - docker:dind
 before_script:
    - export REVISION=$(git rev-parse --short HEAD)
    - docker login -u ${DOCKERHUB_USER} -p ${DOCKERHUB_PASS}
 after_script:
    - docker logout

release:
 stage: release
 <<: *docker_registry
 image: docker:latest
 script:
    - cd ${APP_PATH}/
    - pwd && ls -la
    - docker login -u ${DOCKERHUB_USER} -p ${DOCKERHUB_PASS}
    - docker build -t ntahri/apiexercise:${CI_PIPELINE_ID} .
    - docker tag ntahri/apiexercise:${CI_PIPELINE_ID} ntahri/apiexercise:latest
    - docker push ntahri/apiexercise:${CI_PIPELINE_ID}
    - docker push ntahri/apiexercise:latest

deploy_staging:
  stage: deploy
  image: claranet/gcloud-kubectl-docker
  before_script:
    - cd ${APP_PATH}/
    - pwd && ls -la
    - kubectl config set-cluster api-exercise --server="${K8S_DEV_SERVER}" --certificate-authority=kubernetes/ca.crt
    - kubectl config set-context api-exercise --cluster=api-exercise
    - kubectl config set-credentials "${K8S_DEV_USER}" --token="${K8S_DEV_TOKEN}"
    - kubectl config set-context api-exercise --user="${K8S_DEV_USER}"
    - kubectl config use-context api-exercise
    - kubectl config set-context $(kubectl config current-context) --namespace=exercise
  script:
    - kubectl set image deployment/api-exercise api-exercise=ntahri/apiexercise:${CI_PIPELINE_ID} -nexercise
  environment:
    name: exercise
    url: https://35.192.221.203
  only:
    - master
